function Dungeon::build(%this)
{
	if (%this._isBuilding)
	{
		return;
	}

	%this._isBuilding = 1;
	%this._calculateBuildProperties();

	if(getRandom(0, 1)) {
		serverPlay2D(BeginLevel1);
	} else {
		serverPlay2D(BeginLevel2);
	}
	
	%this.baseLoadText = "<font:palatino linotype:48><color:FFFF66>Loading\n";
	%this.baseLoadText = %this.baseLoadText @ "<font:palatino linotype:32>\c6Floor " @ %this.session.level @ "\n";
	%this.baseLoadText = %this.baseLoadText @ "<font:palatino linotype:24>\n\c6";

	%this.buildPhase1();
	%this.miniGame.centerPrintAll(%this.baseLoadText @ "Giving you something to stand on", 0);

	if (isObject(%this.miniGame))
	{
		for (%i = 0; %i < %this.miniGame.numMembers; %i++)
		{
			%member = %this.miniGame.member[%i];

			if (isObject(%member.player))
			{
				%member.player.delete();
			}

			%member.camera.setFlyMode();
			%member.setControlObject(%member.camera);
		}
	}
}

function Dungeon::stopBuild(%this)
{
	%this._isBuilding = 0;

	if (isEventPending(%this.buildSchedule))
	{
		cancel(%this.buildSchedule);
	}
}

function Dungeon::_buildingFinished(%this)
{
	%this._isBuilding = 0;
	%this.spawnArea = %this.pickSpawnPoint("", "", "", 1);

	if (isObject(%this.miniGame))
	{
		for (%i = 0; %i < %this.miniGame.numMembers; %i++)
		{
			commandToClient(%this.miniGame.member[%i], 'ClearBottomPrint');
			schedule(1000, 0, "commandToClient", %this.miniGame.member[%i], 'ClearCenterPrint');
		}

		%this.miniGame.reset(0, 1);
		%this.schedule(10000, "placeGhosts");
	}
}

function Dungeon::placeGhosts(%this)
{
	%mul = this.session.level / 2;

	if(%mul < 1) {
		%mul = 1;
	}

	%density = 0.05 * %mul;
	%boss = 0.01 * %mul;

	%spawned = 0;

	for (%x = %this.dirtyMinX; %x <= %this.dirtyMaxX; %x++)
	{
		for (%y = %this.dirtyMinY; %y <= %this.dirtyMaxY; %y++)
		{
			%class = %this.grid[%x, %y].class;

			if (%class !$= Room && %class !$= Corridor)
			{
				continue;
			}

			if (%this._isTrap[%x, %y] || %this._isStructure[%x, %y])
			{
				continue;
			}

			if (%this._walls[%x, %y] >= 4)
			{
				continue;
			}

			%position = vectorAdd(vectorScale(%x SPC %y, 8), "4 4 8.5");

			if (vectorDist(%this.spawnArea, %position) <= 40)
			{
				continue;
			}

			if (getRandom() < %density)
			{
				if (getRandom() < %boss)
				{
					%boss *= 0.2;
					%ghost = spawnGhost(getRandomGhostArmor(1), %position);

					%ghost.setShapeName(%ghost.getDataBlock().ghostName);
					%ghost.setShapeNameColor("1 1 0");
				}
				else
				{
					spawnGhost(getRandomGhostArmor(), %position);
				}

				%spawned += 1;
			}
		}
	}

	echo(%spawned SPC "spooky ghosts");

	return;

	%amount = mFloatLength(%this.miniGame.numMembers * (1.5 + getRandom() * 1.5), 0);

	if (%amount < 8)
	{
		%amount = 8;
	}

	for (%i = 0; %i < %amount; %i++)
	{
		%area = %this.pickSpawnPoint(1, %this.spawnArea, 50);
		%area = vectorAdd(%area, getRandom() * 2 - 1 SPC getRandom() * 2 - 1);

		schedule(%i * 100, 0, "spawnGhost", getRandomGhostArmor(), %area);
	}
}

// =========================================
// BUILD PROPERTIES
// Pre-determine where features should be.
// =========================================

function Dungeon::_calculateBuildProperties(%this) {
	%offsets = "0 1\t1 0\t0 -1\t-1 0";

	//%this.pillarThreshold = getRandom() * 0.5;
	//%this.pillarThreshold = 0.05;
	//%this.pillarThreshold = 0;
	%this.pillarThreshold = 0.35;
	//%this.wallThreshold = 0.3 + getRandom() * 0.6;
	%this.wallThreshold = 0;

	for (%x = %this.dirtyMinX; %x <= %this.dirtyMaxX; %x++) {
		for (%y = %this.dirtyMinY; %y <= %this.dirtyMaxY; %y++) {
			%obj = %this.grid[%x, %y];
			%class = %obj.class;

			%this._walls[%x, %y] = 0;

			%this._isPit[%x, %y] = %class $= Pit;
			%this._isTrap[%x, %y] = %obj.isTrap;

			%this._allowStructure[%x, %y] = %class $= Room && !%obj.isTrap && !%obj.isWin;
			%this._allowDebris[%x, %y] = %class !$= Pit && !%obj.isTrap && !%obj.isWin;

			%this._isStructure[%x, %y] = "";
			%this._isDebris[%x, %y] = "";
			%this._isMisc[%x, %y] = "";

			for (%i = 0; %i < 4; %i++) {
				%offset = getField(%offsets, %i);

				%rx = %x + getWord(%offset, 0);
				%ry = %y + getWord(%offset, 1);

				if (%this._doWallCalc(%x, %y, %rx, %ry)) {
					%this._wall[%x, %y, %rx, %ry] = 1;
					%this._wall[%x, %y, %i] = 1;

					%this._walls[%x, %y]++;
				}
				else {
					%this._wall[%x, %y, %rx, %ry] = 0;
					%this._wall[%x, %y, %i] = 0;
				}
			}
		}
	}
}

function Dungeon::_doWallCalc(%this, %x1, %y1, %x2, %y2) {
	%obj1 = %this.isWithinBounds(%x1, %y1) ? %this.grid[%x1, %y1] : -1;
	%obj2 = %this.isWithinBounds(%x2, %y2) ? %this.grid[%x2, %y2] : -1;

	if (!isObject(%obj1) || !isObject(%obj2)) {
		// Something <-> Nothing walls
		return 1;
	}

	if (%obj1.class $= %obj2.class) {
		return 0;
	}

	return 0;

	if (%obj1.class $= Pit || %obj2.class $= Pit) {
		// Pit <-> Something walls
		//return getRandom() > 0.5;
		return getRandom() > (%this.wallThreshold * 1.4);
	}

	// Room <-> Corridor walls
	//return getRandom() >= 0.2;
	return getRandom() >= %this.wallThreshold;
}

// =========================================
// Place floors, traps and pits.
function Dungeon::buildPhase1(%this, %x, %y)
{
	cancel(%this.buildSchedule);

	if (%x $= "")
	{
		%x = %this.dirtyMinX;
	}

	if (%y $= "")
	{
		%y = %this.dirtyMinY;
	}

	%limit = 4;

	for (%x; %x <= %this.dirtyMaxX; %x++)
	{
		for (%y; %y <= %this.dirtyMaxY; %y++)
		{
			if (%count >= %limit)
			{
				%this.buildSchedule = %this.schedule(25, buildPhase1, %x, %y);
				return;
			}

			if (!isObject(%this.grid[%x, %y]) || %this._isMisc[%x, %y])
			{
				continue;
			}

			if (%this._isPit[%x, %y])
			{
				%this._buildPit(%x, %y);
			}
			else
			{
				if (%this.grid[%x, %y].isTrap)
				{
					//%tile = "duntrap" @ getRandom(0, 3);
					%tile = "duntrap" @ getRandom(0, 5);
				}
				else if (%this.grid[%x, %y].isWin)
				{
					%tile = "dunwin";
				}
				else
				{
					%tile = "dunfloor" @ (getRandom() <= 0.3 ? getRandom(1, 2) : 0);
				}

				%this.placeTile(%tile, %x, %y, 0.1, getRandom(0, 3));
			}

			%count++;
		}

		%y = %this.dirtyMinY;
	}

	%this.buildPhase2();
	%this.miniGame.centerPrintAll(%this.baseLoadText @ "Walling everything up", 0);
	//%this._buildingFinished();
}

// =========================================
// Place walls.
function Dungeon::buildPhase2(%this, %x, %y)
{
	cancel(%this.buildSchedule);

	if (%x $= "")
	{
		%x = %this.dirtyMinX;
	}

	if (%y $= "")
	{
		%y = %this.dirtyMinY;
	}

	%limit = 4;

	for (%x; %x <= %this.dirtyMaxX; %x++)
	{
		for (%y; %y <= %this.dirtyMaxY; %y++)
		{
			if (%count >= %limit)
			{
				%this.buildSchedule = %this.schedule(25, buildPhase2, %x, %y);
				return;
			}

			if (!isObject(%this.grid[%x, %y]) || %this._isMisc[%x, %y])
			{
				continue;
			}

			%this._buildWall(%x, %y);
			%count++;
		}

		%y = %this.dirtyMinY;
	}

	%this.buildPhase3();
	%this.miniGame.centerPrintAll(%this.baseLoadText @ "Blocking out sunlight", 0);
}

// =========================================
// Place rooves.
function Dungeon::buildPhase3(%this, %x, %y)
{
	cancel(%this.buildSchedule);

	if (%x $= "")
	{
		%x = %this.dirtyMinX;
	}

	if (%y $= "")
	{
		%y = %this.dirtyMinY;
	}

	%limit = 4;

	for (%x; %x <= %this.dirtyMaxX; %x++)
	{
		for (%y; %y <= %this.dirtyMaxY; %y++)
		{
			if (%count >= %limit)
			{
				%this.buildSchedule = %this.schedule(25, buildPhase3, %x, %y);
				return;
			}

			if (!isObject(%this.grid[%x, %y]) || %this._isMisc[%x, %y])
			{
				continue;
			}

			%this._buildRoof(%x, %y);
			%count++;
		}

		%y = %this.dirtyMinY;
	}

	%this.buildPhase4();
	%this.miniGame.centerPrintAll(%this.baseLoadText @ "Making a mess", 0);
}

// =========================================
// Place structures and debris.
function Dungeon::buildPhase4(%this)
{
	for (%x = %this.dirtyMinX; %x <= %this.dirtyMaxX; %x++)
	{
		for (%y = %this.dirtyMinY; %y <= %this.dirtyMaxY; %y++)
		{
			if (!isObject(%this.grid[%x, %y]) || %this._isMisc[%x, %y])
			{
				continue;
			}

			if (%this._allowStructure[%x, %y] && getRandom() <= 0.15)
			{
				%this._isStructure[%x, %y] = 1;
				%this._allowDebris[%x, %y] = 0;

				%this.placeTile("dunstruc" @ getRandom(0, 3), %x, %y, 8, getRandom(0, 3));
			}

			if (%this._allowDebris[%x, %y] && getRandom() <= 0.3)
			{
				%this._isDebris[%x, %y] = 1;
				%this.placeTile("dundebris" @ getRandom(0, 3), %x, %y, 8, getRandom(0, 3));
			}
		}

		%y = %this.dirtyMinY;
	}

	%this._buildingFinished();
}

// =========================================
// MISC
// =========================================

function Dungeon::_buildPit(%this, %x, %y, %tileOffsetX, %tileOffsetY) {
	if (%this._isMisc[%x, %y]) {
		return;
	}

	%offsets = "0 1\t1 0\t0 -1\t-1 0";
	%neighbors = 0;

	for (%i = 0; %i < 4; %i++) {
		%offset = getField(%offsets, %i);

		%rx = %x + getWord(%offset, 0);
		%ry = %y + getWord(%offset, 1);

		if (%this.isWithinBounds(%rx, %ry) && %this.grid[%rx, %ry].class $= Pit) {
			if (%missingNeighbor $= "" || %missingNeighbor == %i) {
				%missingNeighbor = %i + 1;
			}

			if (%existingNeighbor $= "") {
				%existingNeighbor = %i;
			}

			%neighbor[%i] = 1;
			%neighbors++;
		}
	}

	if (%missingNeighbor $= 4) {
		%missingNeighbor = "";
	}

	if (%neighbors == 0) {
		%this.placeTile("dunpit1", %x, %y, 0, 0);
		%this.placeTile("dunpit1", %x, %y, 0, 2);
	}
	else if (%neighbors == 1) {
		%this.placeTile("dunpit1", %x, %y, 0, %existingNeighbor + 1);
		%this.placeTile("dunpit1", %x, %y, 0, %existingNeighbor + 2);
	}
	else if (%neighbors == 2) {
		if (%neighbor0 && %neighbor2) {
			%this.placeTile("dunpit0", %x, %y, 0, 0);
			%this.placeTile("dunpit0", %x, %y, 0, 2);
		}
		else if (%neighbor1 && %neighbor3) {
			%this.placeTile("dunpit0", %x, %y, 0, 1);
			%this.placeTile("dunpit0", %x, %y, 0, 3);
		}
		else {
			if (%neighbor0 && %neighbor1) {
				%this.placeTile("dunpit1", %x, %y, 0, 2);
			}
			else if (%neighbor1 && %neighbor2) {
				%this.placeTile("dunpit1", %x, %y, 0, 3);
			}
			else if (%neighbor2 && %neighbor3) {
				%this.placeTile("dunpit1", %x, %y, 0, 0);
			}
			else if (%neighbor3 && %neighbor0) {
				%this.placeTile("dunpit1", %x, %y, 0, 1);
			}
		}
	}
	else if (%neighbors == 3) {
		%this.placeTile("dunpit0", %x, %y, 0, %missingNeighbor);
	}
	else if (%neighbors == 4) {
		%this.placeTile("dunpit2", %x, %y, 0, 0);
	}
}

function Dungeon::_buildRoof(%this, %x, %y) {
	if (%this._isMisc[%x, %y]) {
		return;
	}

	%offsets = "0 1\t1 0\t0 -1\t-1 0";
	%neighbors = 0;

	for (%i = 0; %i < 4; %i++) {
		%offset = getField(%offsets, %i);

		%rx = %x + getWord(%offset, 0);
		%ry = %y + getWord(%offset, 1);

		if (%this.isWithinBounds(%rx, %ry) && isObject(%this.grid[%rx, %ry])) {
			%neighbor[%i] = 1;
			%neighbors++;
		}
	}

	if (%neighbors == 2) {
		if (%neighbor0 && %neighbor2) {
			%pathDirection = 1;
		}
		else if (%neighbor1 && %neighbor3) {
			%pathDirection = 0;
		}

		if (getRandom() < 0.5) {
			%pathDirection += 2;
		}
	}

	%roofTileIndex = getRandom(0, 2);
	%this.placeTile("dunroof" @ %roofTileIndex, %x, %y, 14.6, %pathDirection);

	if (%pathDirection $= "" && %roofTileIndex != 2) {
		%pathDirection = getRandom(0, 3);
	}

	if (%pathDirection $= "") {
		%this.placeTile("dungrass" @ getRandom(0, 2), %x, %y, 15.8, 0);
	}
	else {
		%this.placeTile("dunridge" @ getRandom(0, 6), %x, %y, 15.8, %pathDirection);
	}
}

function Dungeon::_buildWall(%this, %x, %y) {
	if (%this._isMisc[%x, %y]) {
		return;
	}

	%offsets = "0 1\t1 0\t0 -1\t-1 0";
	%walls = 0;

	for (%i = 0; %i < 4; %i++) {
		if (%this._wall[%x, %y, %i]) {
			if (%missingNeighbor $= "" || %missingNeighbor == %i) {
				%missingNeighbor = %i + 1;
			}

			%wall[%i] = 1;
			%walls++;
		}
	}

	if (%missingNeighbor $= 4) {
		%missingNeighbor = "";
	}

	if (%walls == 3) {
		if (!%wall0) {
			%back = 2;
		}
		else if (!%wall1) {
			%back = 3;
		}
		else if (!%wall2) {
			%back = 0;
		}
		else if (!%wall3) {
			%back = 1;
		}

		for (%i = 0; %i < 4; %i++) {
			if (%wall[%i] && %i != %back) {
				%this.placeTile(getWallTile(), %x, %y, 8, %i + 2);
			}
		}

		%offset = getField(%offsets, %back);

		%rx = %x + getWord(%offset, 0);
		%ry = %y + getWord(%offset, 1);

		if (isObject(%this.space[%rx, %ry])) {
			%this._placeMisc(%rx, %ry);
		}
		else {
			%this.placeTile("dunback" @ getRandom(0, 2), %rx, %ry, 8, %back);

			if (!isObject(%this.grid[%rx, %ry])) {
				%this._buildRoof(%rx, %ry);
			}
		}

		if (!isObject(%this.grid[%rx, %ry])) {
			%this._buildRoof(%rx, %ry);
		}

		%this._buildPillar(%x, %y);
		return;
	}

	if (%walls == 2) {
		if (%wall0 && %wall1) {
			%sides = "0 1";
		}
		else if (%wall1 && %wall2) {
			%sides = "1 2";
		}
		else if (%wall2 && %wall3) {
			%sides = "2 3";
		}
		else if (%wall3 && %wall0) {
			%sides = "3 0";
		}
	}

	if (%sides $= "") {
		for (%i = 0; %i < 4; %i++) {
			if (%wall[%i]) {
				%this.placeTile(getWallTile(), %x, %y, 8, %i + 2);

				// if (%obj.class $= Room) {
				// 	%this.placeTile("dunback" @ getRandom(0, 3), %rx, %ry, 8, %i + 2);
				// }
			}
		}
	}
	else {
		for (%i = 0; %i < 2; %i++) {
			%side = getWord(%sides, %i);
			%offset = getField(%offsets, %side);

			%rx = %x + getWord(%offset, 0);
			%ry = %y + getWord(%offset, 1);

			if (!isObject(%this.grid[%rx, %ry])) {
				if (isObject(%this.space[%rx, %ry])) {
					%this._placeMisc(%rx, %ry);
				}
				else {
					%this.placeTile("dunback" @ getRandom(0, 2), %rx, %ry, 8, %side);

					if (!isObject(%this.grid[%rx, %ry])) {
						%this._buildRoof(%rx, %ry);
					}
				}
			}
		}
	}

	%this._buildPillar(%x, %y);
}

function Dungeon::_buildPillar(%this, %x, %y)
{
	if (getRandom() >= %this.pillarThreshold)
	{
		return;
	}

	for (%i = 0; %i < 4; %i++)
	{
		%this.placeTile("dunpillar" @ getRandom(0, 4), %x, %y, 8, %i + 2);
	}
}

function Dungeon::_placeMisc(%this, %x, %y) {
	if (%this._isMisc[%x, %y]) {
		return;
	}

	if (isObject(%this.space[%x, %y])) {
		%this.space[%x, %y].delete();
	}

	%this.placeTile("dunfloor0", %x, %y, 0.1, 0);
	%this.placeTile("dunmisc1", %x, %y, 8, 0);

	%this._buildRoof(%x, %y);
	%this._isMisc[%x, %y] = 1;
}

function getWallTile() {
	// return "dunwall" @ getRandom(0, 4);
	%lit = getRandom() <= 0.1;

	if (%lit) {
		return "dunwall1";
	}
	else {
		%index = getRandom(0, 3);

		if (%index != 0) {
			%index++;
		}

		return "dunwall" @ %index;
	}
}
