function GridSpace(%dungeon, %x, %y)
{
	return new ScriptGroup()
	{
		class = GridSpace;
		dungeon = %dungeon;

		x = mFloor(%x);
		y = mFloor(%y);
	};
}

function GridSpace::onRemove(%this)
{
	for (%i = %this.getCount() - 1; %i >= 0; %i--)
	{
		%set = %this.getObject(%i);

		if (isObject(%set.trigger))
		{
			%set.trigger.delete();
		}

		%set.deleteAll();
		%set.delete();
	}
}

function GridSpace::placeTile(%this, %tileName, %z, %angle)
{
	if (!isObject(BrickGroup_888888))
	{
		error("ERROR: BrickGroup_888888 does not exist!");
		return 0;
	}

	%tile = nameToID("kogTile_" @ %tileName);

	if (!isObject(%tile))
	{
		error("ERROR: Invalid tile '" @ %tileName @ "'.");
		return 0;
	}

	%x = 4 + %this.x * 8;
	%y = 4 + %this.y * 8;

	%angle = %angle % 4;

	if (%z < 0.1)
	{
		%z = 0.1;
	}

	%set = new SimSet()
	{
		isTileSet = 1;

		gridSpace = %this;
		dungeon = %this.dungeon;

		tile = %tile;
		tileName = %tileName;

		z = %z;
		angle = %angle;
	};

	%this.add(%set);
	%tile.place(%set, %x, %y, %z, %angle);
}
