function KOGSession(%miniGame)
{
	if (!isObject(%miniGame))
	{
		error("ERROR: Invalid mini-game.");
		return -1;
	}

	%obj = new ScriptObject()
	{
		class = KOGSession;
		miniGame = %miniGame;
	};

	if (isObject(MissionCleanup))
	{
		MissionCleanup.add(%obj);
	}

	return %obj;
}

function KOGSession::onAdd(%this)
{
	%this.level = 1;
	%this.createDungeon();
}

function KOGSession::onRemove(%this)
{
	if (isObject(%this.dungeon))
	{
		%this.dungeon.delete();
	}
}

function KOGSession::nextLevel(%this)
{
	if (isObject(%this.dungeon))
	{
		%this.dungeon.delete();
	}

	%this.level++;
	%this.schedule(100, "createDungeon");
}

function KOGSession::pickSpawnPoint(%this, %mode, %origin, %distance)
{
	if (isObject(%this.dungeon) && !%this.dungeon._isBuilding)
	{
		return %this.dungeon.pickSpawnPoint(%mode, %origin, %distance);
	}

	return pickSpawnPoint();
}

function KOGSession::createDungeon(%this)
{
	if (isObject(%this.dungeon))
	{
		return;
	}

	%mul = %this.level / 2;

	%this.dungeon = createDungeon(%mul);
	%this.dungeon.session = %this;
	%this.dungeon.miniGame = %this.miniGame;
	%this.dungeon.build();
}

function KOGSession::survivorCheck(%this)
{
	%dead = 0;

	for (%i = 0; %i < $DefaultMiniGame.numMembers; %i++)
  	{
  		if(!isObject($DefaultMiniGame.member[%i].player)) {
  			%dead += 1;
  		}
  	}

  	if(%dead >= $DefaultMiniGame.numMembers) {
  		messageAll('', "<color:FF0000>Everybody has died. What a shame.");
  		%this.miniGame.scheduleReset(3000);
  	}
}