function KOGTile::onAdd(%this)
{
	%fp = new FileObject();
	%fp.openForRead(%this.file);

	%this.brickCount = 0;
	%index = -1;

	%fp.readLine();
	%fp.readLine();
	%fp.readLine();

	while (!%fp.isEOF())
	{
		%line = %fp.readLine();
		%index++;

		if (getSubStr(%line, 0, 2) $= "+-")
		{
			if (%this.brickCount)
			{
				%this.data[%this.brickCount - 1] = %this.data[%this.brickCount - 1] NL %line;
			}

			continue;
		}
		else if (strPos(%line, "\"") == -1)
		{
			if (%index < 64)
			{
				%color[%index] = getClosestPaintColor(%line);
			}

			continue;
		}

		%uiName = getSubStr(%line, 0, strPos(%line, "\""));

		if (!isObject($uiNameTable[%uiName]))
		{
			warn("Unknown brick datablock:" SPC %uiName);
			continue;
		}

		if (%initialPos $= "")
		{
			%initialPos = getValueFromBrickStr(%line, "position");
		}

		if (!%skippedRoofBase && getSubStr(%this.name, 0, 7) $= "dunroof")
		{
			%test = strReplace(%line, %uiName @ "\" ", "");
			%baseplate = getWord(%test, 4);

			if (%baseplate)
			{
				%skippedRoofBase = 1;
				continue;
			}
		}

		%position = getValueFromBrickStr(%line, "position");
		%color = %color[getValueFromBrickStr(%line, "colorID")];

		%data = strReplace(%line, %position, vectorSub(%position, %initialPos));
		%search = getSubStr(%line, strPos(%line, "\" ") + 2, strLen(%line));
		%data = strReplace(%data, %search, setWord(%search, 5, %color));

		%this.brickCount++;
		%this.data[%this.brickCount - 1] = %data;
	}

	%fp.close();
	%fp.delete();
}

function KOGTile::place(%this, %set, %x, %y, %z, %angle)
{
	for (%i = 0; %i < %this.brickCount; %i++)
	{
		%this.placeSingle(%set, %this.data[%i], %x SPC %y SPC %z, %angle);
	}

	if (isFunction(%this.getName(), "onPlant"))
	{
		echo("yeah");
		%this.onPlant(%set, %x SPC %y SPC %z, %angle);
	}
}

function KOGTile::placeSingle(%this, %set, %str, %positionOffset, %angleOffset) {
	if(%str $= "") {
		return -1;
	}

	%datablock = getValueFromBrickStr(%str, "datablock");
	%line = strReplace(getLine(%str, 0), %datablock @ "\" ", "");
	%position = getWords(%line, 0, 2);
	%angle = getWord(%line, 3);
	%baseplate = getWord(%line, 4);
	%color = getWord(%line, 5);
	%print = getWord(%line, 6);
	%colorFX = getWord(%line, 7);
	%shapeFX = getWord(%line, 8);
	%raycasting = getWord(%line, 9);
	%colliding = getWord(%line, 10);
	%rendering = getWord(%line, 11);

	%angle += %angleOffset;

	if (%angle > 3) {
		%angle -= 4;
	}

	if (%angle < 0) {
		%angle += 4;
	}

	%position = vectorRot(%position, %angleOffset);
	%position = vectorAdd(%position, %positionOffset);

	%brick = new fxDTSBrick() {
		datablock = $uiNameTable[%datablock];

		position = %position;
		rotation = rotationFromAngleID(%angle);

		colorID = %color;
		angleID = %angle;
		printID = $printNameTable[%print];

		colorFxID = %colorFX;
		shapeFxID = %shapeFX;

		isPlanted = 1;
	};

	if (!isObject(%brick)) {
		return -1;
	}

	BrickGroup_888888.add(%brick);
	%set.add(%brick);

	%brick.setTrusted(1);
	%error = %brick.plant();

	if (%error != 0 && %error != 2) {
		%brick.delete();
		return %error;
	}

	if (!%raycasting) {
		%brick.setRaycasting(0);
	}

	if (!%colliding) {
		%brick.setColliding(0);
	}

	if (!%rendering) {
		%brick.setRendering(0);
	}

	for(%i=1;%i<getLineCount(%str);%i++)
	{
		%line = getLine(%str,%i);
		if(firstWord(%line) $= "+-OWNER")
			continue;
		if(firstWord(%line) !$= "+-NTOBJECTNAME" && getField(%line,0) !$= "+-EVENT")
			%ui = restWords(getSubStr(%line,0,strpos(%line,"\"")));
		else if(firstWord(%line) $= "+-NTOBJECTNAME")
			%brick.setNTObjectName(getWord(%line,1));
		if(firstWord(%line) $= "+-VEHICLE")
		{
			%val = getSubStr($s,strpos($s,"\"")+2,strpos($s," ",strpos($s,"\"")));
			%brick.setRecolorVehicle(%val);
			%brick.setVehicle($uiNameTable_Vehicle[%ui]);
		}
		if(firstWord(%line) $= "+-EMITTER")
		{
			%dir = getSubStr(%line,strpos(%line,"\" ")+2,strLen(%line));
			//Is it NSWE?
			if(%dir-2 >= 0)
				%dir += %angleOffset;
			if(%dir-2 > 3)
					%dir -= 4;
			%brick.emitterDirection = %dir;
			%brick.setEmitter($uinameTable_Emitters[%ui]);
		}
		if(firstWord(%line) $= "+-LIGHT")
			%brick.setLight($uinameTable_Lights[%ui]);
		if(firstWord(%line) $= "+-ITEM")
		{
			%d = getSubStr(%line,strpos(%line,"\" ")+2,strLen(%line));
			%dir = getWord(%d,1);
			%pos = getWord(%d,0);
			%respawnTime = getWord(%d,2);
			if(%dir-2 >= 0)
				%dir += %angleOffset;
			if(%dir-2 > 3)
					%dir -= 4;
			if(%pos-2 >= 0)
				%pos += %angleOffset;
			if(%pos-2 > 3)
					%pos -= 4;
			%brick.itemPosition = %pos;
			%brick.itemDirection = %dir;
			%brick.itemRespawnTime = %respawnTime;
			%brick.setItem($uiNameTable_Items[%ui]);
		}
		if(firstWord(%line) $= "+-AUDIOEMITTER")
			%brick.setMusic($uiNameTable_Music[%data]);
		if(getField(%line,0) $= "+-EVENT")
		{
			%num = getField(%line,1);
			%brick.eventEnabled[%num] = getField(%line, 2);
			%brick.eventInput[%num] = getField(%line, 3);
			%brick.eventInputIdx[%num] = inputEvent_GetInputEventIdx(%brick.eventInput[%num]);
			%brick.eventDelay[%num] = getField(%line, 4);
			%brick.eventTarget[%num] = getField(%line, 5);
			%brick.eventTargetIdx[%num] = inputEvent_GetTargetIndex("fxDtsBrick", %brick.eventInputIdx[%num], %brick.eventTarget[%num]);
			%brick.eventNT[%num] = getField(%line, 6);
			%outputClass = %brick.eventTargetIdx[%num] == -1 ? "fxDtsBrick" : inputEvent_GetTargetClass("fxDtsBrick", %brick.eventInputIdx[%num], %brick.eventTargetIdx[%num]);
			%brick.eventOutput[%num] = getField(%line, 7);
			%brick.eventOutputIdx[%num] = outputEvent_GetOutputEventIdx(%outputClass,%brick.eventOutput[%num]);
			%brick.eventOutputAppendClient[%num] = $OutputEvent_AppendClient[%outputClass,%brick.eventOutputIdx[%num]];

			for(%e = 1; %e <= 4; %e++)
			{
				%eventParamType = getField($OutputEvent_parameterList[%outputClass, %brick.eventOutputIdx[%num]], %e - 1);
				if(getWord(%eventParamType, 0) $= "dataBlock" && isObject(getField(%line, %e + 7)))
					%brick.eventOutputParameter[%num,%e] = getField(%line, %e + 7).getId();
				else
					%brick.eventOutputParameter[%num, %e] = getField(%line, %e + 7);
				if(getWord(%eventParamType,0) $= "vector")
					%brick.eventOutputParameter[%num, %e] = vectorRot(getField(%line, %e + 7),%angleOffset);
				else if(getWord(%eventParamType,0) $= "list")
				{
					if(stripos(%eventParamType,"North") != -1)
					{
						%off = 0;
						if(stripos(%eventParamType,"Up"))
							%off++;
						if(stripos(%eventParamType,"Down"))
							%off++;
						%value = %brick.eventOutputParameter[%num, %e];
						if(%value-2 >= 0)
							%value+=%angleOffset;
						if(%value-2 > 3)
							%value -= 4;
						%brick.eventOutputParameter[%num, %e] = %value;
					}
				}
			}
			%brick.numEvents++;
			%brick.implicitCancelEvents = 0;
			if(strpos(%brick.eventOutput[%num],"fireRelay") != -1)
			{
				%output = %brick.eventOutput[%num];
				%dir = getSubStr(%output,strLen("fireRelay"),strLen(%output));
				switch$(%dir)
				{
					case "North":
						%dir = 0;
					case "West":
						%dir = 1;
					case "South":
						%dir = 2;
					case "East":
						%dir = 3;
					default:
						continue;
				}
				%dir -= %angleOffset;
				if(%dir < 0)
					%dir += 4;
				switch(%dir)
				{
					case 0:
						%output = "fireRelayNorth";
					case 1:
						%output = "fireRelayWest";
					case 2:
						%output = "fireRelaySouth";
					case 3:
						%output = "fireRelayEast";
				}
				%brick.eventOutput[%num] = %output;
				%brick.eventOutputIDX[%num] = outputEvent_GetOutputEventIdx("fxDTSBrick",%output);
			}
		}
	}

	return %brick;
}

function getValueFromBrickStr(%string,%value) {
	if (%string $= "") {
		return;
	}

	%datablock = getSubStr(%string, 0, strPos(%string, "\""));
	%string = strReplace(%string, %datablock @ "\" ", "");

	if (%value $= "datablock") {
		return %datablock;
	}
	else if (%value $= "position") {
		return getWords(%string, 0, 2);
	}
	else if (%value $="angleID") {
		return getWord(%string, 3);
	}
	else if (%value $= "colorID") {
		return getWord(%string, 5);
	}
	else if (%value $= "printID") {
		return $printNameTable[getWord(%string, 6)];
	}
}

function vectorRot(%vector, %rotation) {
	if(!%rotation) {
		return %vector;
	}

	if(%rotation == 1) {
		return getWord(%vector, 1) SPC -getWord(%vector, 0) SPC getWord(%vector, 2);
	}
	if(%rotation == 2) {
		return -getWord(%vector, 0) SPC -getWord(%vector, 1) SPC getWord(%vector, 2);
	}
	else if(%rotation == 3) {
		return -getWord(%vector, 1) SPC getWord(%vector, 0) SPC getWord(%vector, 2);
	}
}

function getClosestPaintColor(%rgba) {
	%prevdist = 100000;
	%colorMatch = 0;

	for (%i = 0; %i < 64; %i++) {
		%color = getColorIDTable(%i);

		if(vectorDist(%rgba,getWords(%color,0,2)) < %prevdist && getWord(%rgba,3) - getWord(%color,3) < 0.3 && getWord(%rgba,3) - getWord(%color,3) > -0.3)
		{
			%prevdist = vectorDist(%rgba, %color);
			%colormatch = %i;
		}
	}

	return %colormatch;
}

function rotationFromAngleID(%angle) {
	switch (%angle) {
		case 0: %rotation = "1 0 0 0";
		case 1: %rotation = "0 0 1 90";
		case 2: %rotation = "0 0 1 180";
		default: %rotation = "0 0 -1 90";
	}

	return %rotation;
}

function loadKOGTiles(%pattern)
{
	if (!isObject(KOGTileGroup))
	{
		new ScriptGroup(KOGTileGroup);
	}

	for (%file = findFirstFile(%pattern); %file !$= ""; %file = findNextFile(%pattern))
	{
		if (%file $= %pattern)
		{
			continue;
		}

		%base = fileBase(%file);
		%name = "kogTile_" @ %base;

		if (isObject(%name))
		{
			continue;
		}

		echo("Loading tile" SPC fileBase(%file));

		%obj = new ScriptObject(%name)
		{
			class = KOGTile;

			file = %file;
			name = %base;
		};

		KOGTileGroup.add(%obj);
	}
}
