package KOGPlayerPackage
{
	function serverCmdLight(%client)
	{
		Parent::serverCmdLight(%client);

		if (!isObject(%client.player.light))
		{
			return;
		}

		if (!isObject(%client.miniGame) || %client.miniGame.owner != 0)
		{
			return;
		}

		%client.player.light.setDataBlock(PlayerKOGLight);
	}

	function serverCmdGreenLight(%client)
	{
		if (!isObject(%client.miniGame) || %client.miniGame.owner != 0)
		{
			Parent::serverCmdGreenLight(%client);
		}
	}
};

activatePackage("KOGPlayerPackage");

datablock PlayerData(PlayerKOGArmor : PlayerStandardArmor)
{
	uiName = "KOG Player";
	canJet = 0;

	cameraMaxDist = 3.25;
	cameraTilt = 0.2;

	mass = 120;
	airControl = 0.5;

	runForce = 5000;
	jumpDelay = 10;

	isKOGPlayer = 1;

	maxHealth = 300;
};

datablock PlayerData(PlayerKOGSlowedArmor : PlayerKOGArmor)
{
	uiName = "";

	runForce = 0;
	jumpForce = 0;
};

datablock FxLightData(PlayerKOGLight : PlayerLight)
{
	uiName = "KOG Light";

	color = "0.972549 0.764706 0.466667 1";
	constantSize = 0.6;

	animBrightness = 1;
	lerpBrightness = 1;
	brightnessKeys = "AZA";

	minBrightness = 0.25;
	maxBrightness = 0.75;
};

registerOutputEvent("Player", "stun", "float 0.1 10.0 0.1 3.0");

function Player::stun(%this, %time)
{
	if (!%this.getDataBlock().isKOGPlayer)
	{
		return;
	}

	%time = mClamp(%time * 1000, 0, 10000);

	if (isEventPending(%this.unstunSchedule))
	{
		if (getTimeRemaining(%this.unstunSchedule) < %time)
		{
			cancel(%this.unstunSchedule);
		}
		else
		{
			return;
		}
	}

	%this.setDataBlock(PlayerKOGSlowedArmor);
	%this.unstunSchedule = %this.schedule(%time, "setDataBlock", PlayerKOGArmor);
}