datablock TriggerData(WinTriggerData)
{
  isTrigger = 1;
  tickPeriodMS = 100;
};

function kogTile_dunwin::onPlant(%this, %set, %position, %angle)
{
  %trigger = new Trigger()
  {
    datablock = WinTriggerData;
    polyhedron = "0 0 0 1 0 0 0 -1 0 0 0 1";
    dungeon = %set.dungeon;
  };

  %trigger.setTransform(vectorAdd(%position, "-4 4 7.6"));
  %trigger.setScale("8 8 0.5");

  %set.trigger = %trigger;
}

function WinTriggerData::onEnterTrigger(%this, %trigger, %obj)
{
  %client = %obj.client;

  if (!isObject(%client) || %client.miniGame != $DefaultMiniGame)
  {
    return;
  }

  %dungeon = %trigger.dungeon;

  if (!%dungeon.exitReached)
  {
    %dungeon.exitReached = 1;

    messageAll('MsgProcessComplete',
      "\c3" @ %client.getPlayerName() SPC "\c6has reached the exit!" SPC
      "The game will advance to the next level once all living players are there."
    );
  }

  %dungeon.atExit[%client] = 1;

  for (%i = 0; %i < $DefaultMiniGame.numMembers; %i++)
  {
    if (%dungeon.atExit[$DefaultMiniGame.member[%i]] || !isObject($DefaultMiniGame.member[%i].player))
    {
      %present++;
    }
  }

  if (%present >= $DefaultMiniGame.numMembers)
  {
    if (isEventPending(%dungeon.nextLevelSchedule))
    {
      cancel(%dungeon.nextLevelSchedule);
    }

    messageAll('MsgProcessComplete', "\c6All living players have reached the exit. Level complete.");
    %dungeon.nextLevelSchedule = %dungeon.session.schedule(1000, "nextLevel");
  }
  else if (%present >= 5 || %present >= $DefaultMiniGame.numMembers / 2)
  {
    if (!isEventPending(%dungeon.nextLevelSchedule))
    {
      %dungeon.nextLevelSchedule = %dungeon.session.schedule(30000, "nextLevel");

      messageAll('MsgProcessComplete',
        "\c6Most players have reached the exit! The game will advance to" SPC
        "the next level automatically in \c330 seconds\c6."
      );
    }
  }
}

function WinTriggerData::onLeaveTrigger(%this, %trigger, %obj)
{
  %client = %obj.client;

  if (!isObject(%client) || %client.miniGame != $DefaultMiniGame)
  {
    return;
  }

  %trigger.dungeon.atExit[%client] = 0;
}

function MiniGameSO::respawnDeadPlayers(%this)
{
  for (%i = 0; %i < %this.numMembers; %i++)
  {
    %client = %this.member[%i];

    if (!%client.isAlive())
    {
      %client.instantRespawn();
    }
  }
}